/*
 *  * Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 */


// Located in: ppc405_0/include/xparameters.h
#include "xparameters.h"
#include "xuartns550_l.h" 
#include "xutil.h"
#include "xparameters.h"
#include "xio.h"
#include "sleep.h"
#include "xcache_l.h"

#define C_ETHERNET_BASEADDR      XPAR_TRIMODE_MAC_GMII_BASEADDR
#define IPISR          0x00000020UL  /* IP interrupt status register */
#define MGTDR          0x000033B0UL
#define MGTCR          0x000033B4UL
#define EMC            0x00003340UL

/* PHYADDR 0x07 for ML410 RevD, 0x00 for ML410 RevC */
/* #define PHYADDR 0x00 */


void mdio_set_rgmii(void) {
   Xuint32 Register;
   Xuint32 Mdio_Reg;
   Xuint32 PHYADDR;
   Xuint32 Register_RevC;
   Xuint32 Register_RevD;


   // Determine if board is a RevC (PHYADDR = 0x0) or RevD (PHYADDR = 0x7) 
   // by trying to read PHY ID Register (Mdio_Reg = 2)

    Mdio_Reg = 2; /* PHY ID Reg is Register 2 */
    PHYADDR = 0; /* First assume RevC board*/

   // Read MDIO Register
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000400 | Mdio_Reg) | (PHYADDR << 5))); // write to MGTCR to set up MIIM PHY register Read
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);   // wait for the interrupt to tell us MIIM access is complete
    Register &= 0x10000;
    while (Register != 0x10000)
      {
	Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
	Register &= 0x10000;
      }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt
    Register = XIo_In32((C_ETHERNET_BASEADDR) + MGTDR);   // read the mgtdr for PHY Addr: PHYADDR and Reg#: Mdio_Reg
    printf(" PHY addr 0x%x  reg %d  is : 0x%x\n", PHYADDR, Mdio_Reg, Register);
    Register_RevC = Register;



    Mdio_Reg = 2;
    PHYADDR = 7; /* RevC board*/
   // Read MDIO Register
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000400 | Mdio_Reg) | (PHYADDR << 5))); // write to MGTCR to set up MIIM PHY register Read
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);   // wait for the interrupt to tell us MIIM access is complete
    Register &= 0x10000;
    while (Register != 0x10000)
      {
	Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
	Register &= 0x10000;
      }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt
    Register = XIo_In32((C_ETHERNET_BASEADDR) + MGTDR);   // read the mgtdr for PHY Addr: PHYADDR and Reg#: Mdio_Reg
    printf(" PHY addr 0x%x  reg %d  is : 0x%x\n", PHYADDR, Mdio_Reg, Register);
    Register_RevD = Register;

    // Check PHY Indentifier register value and detemine if you have a revC

	if (Register_RevC == 0x141)
	  {
	    PHYADDR = 0x0;
	  }
	else /* assume RevD with PHY Address = 0x07 */
	  {
	    PHYADDR = 0x07;
	  }


    printf("\n Assuming PHY Addr 0x%x \n\n", PHYADDR);


    //---------------------------------------------------------------------------
    // Set up MAC interface
    //---------------------------------------------------------------------------

    // Write MDIO Register
    Mdio_Reg = 20;
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTDR, 0x00000ce3); // write to the mgtdr to disable line loopback, enable link pulses
                                                          // set up downshift counter, set mac interface to 100 Mbs, 25, 25 MHz
                                                          // add delay to both rx_clk and tx_clk

    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000000 | Mdio_Reg) | (PHYADDR << 5))); // write to MGTCR to set up MIIM PHY register Write
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
    Register &= 0x10000;

    while (Register != 0x10000)
    {
      Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
      Register &= 0x10000;
    }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt


    // Read MDIO Register
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000400 | Mdio_Reg) | (PHYADDR << 5))); // write to MGTCR to set up MIIM PHY register Read
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);   // wait for the interrupt to tell us MIIM access is complete
    Register &= 0x10000;
    while (Register != 0x10000)
      {
	Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
	Register &= 0x10000;
      }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt
    Register = XIo_In32((C_ETHERNET_BASEADDR) + MGTDR);   // read the mgtdr for PHY Addr: PHYADDR and Reg#: Mdio_Reg
    printf(" PHY addr 0x%x  reg %d  is : 0x%x\n", PHYADDR, Mdio_Reg, Register);


    //---------------------------------------------------------------------------
    // Set RGMII to copper with correct hysterisis and correct mode
    //---------------------------------------------------------------------------
    Mdio_Reg = 27;
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTDR, 0x0000848b); // write to the mgtdr to disable fiber/copper auto sel, choose copper
                                                        // RGMII /Modified MII to copper mode

    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000000 | Mdio_Reg) | (PHYADDR << 5))); // write to wr to the mgtcr for PHY 0 reg 27
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
    Register &= 0x10000;
    while (Register != 0x10000)
    {
      Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
      Register &= 0x10000;
    }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt

    // Read MDIO Register
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000400 | Mdio_Reg) | (PHYADDR << 5))); // write to MGTCR to set up MIIM PHY register Read
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);   // wait for the interrupt to tell us MIIM access is complete
    Register &= 0x10000;
    while (Register != 0x10000)
      {
	Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
	Register &= 0x10000;
      }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt
    Register = XIo_In32((C_ETHERNET_BASEADDR) + MGTDR);   // read the mgtdr for PHY Addr: PHYADDR and Reg#: Mdio_Reg
    printf(" PHY addr 0x%x  reg %d  is : 0x%x\n", PHYADDR, Mdio_Reg, Register);
 

    //---------------------------------------------------------------------------
    // Reset the PHY
    //---------------------------------------------------------------------------
    Mdio_Reg = 0;
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTDR, 0x00009000); // write to the mgtdr to reset, autoneg
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000000 | Mdio_Reg) | (PHYADDR << 5))); // write to wr to the mgtcr for PHY 0 reg 0
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
    Register &= 0x10000;
    while (Register != 0x10000)
    {
      Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
      Register &= 0x10000;
    }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt

    // Read MDIO Register
    XIo_Out32((C_ETHERNET_BASEADDR) + MGTCR, ((0x00000400 | Mdio_Reg) | (PHYADDR << 5))); // write to MGTCR to set up MIIM PHY register Read
    Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);   // wait for the interrupt to tell us MIIM access is complete
    Register &= 0x10000;
    while (Register != 0x10000)
      {
	Register = XIo_In32((C_ETHERNET_BASEADDR) + IPISR);
	Register &= 0x10000;
      }
    XIo_Out32((C_ETHERNET_BASEADDR) + IPISR, 0x18000);    // clear the interrupt
    Register = XIo_In32((C_ETHERNET_BASEADDR) + MGTDR);   // read the mgtdr for PHY Addr: PHYADDR and Reg#: Mdio_Reg
    printf(" PHY addr 0x%x  reg %d  is : 0x%x\n", PHYADDR, Mdio_Reg, Register);
 
    usleep(5000000); //wait for reset to complete


}


